<?php

/*
	Erluterungen:
	Bestimmte Dinge mssen aufgrund von Abhngigkeiten der Tabellen in einer korrekten Reihenfolge abgearbeitet werden:
	- Module, Layouts, Mandanteneinstellungen, Container und Containerkonfigurationen kopieren
	- Templates und Templatekonfigurationen kopieren
	- Dann anhand der ntigen nderungen der con_art_lang (anhand der idlang) auch die Artikelnummern in con_art anpassen. Hier besteht noch keine Beziehung zu den Kategorien.
	- Dann anhand der ntigen nderungen der con_cat_lang die Kategorienstruktur in con_cat bearbeiten. Hier besteht noch keine Beziehung zu den Artikeln.
	- Dies liefert dann die Grundlage, um alles in der con_cat_art zusammenzufhren (Beziehungen Kategorien <-> Artikel).
	- Dann kommen die Feinheiten der Artikelsteuerung: Artikelinhalte/Content, die Metatags usw.
*/

if(!defined('CON_FRAMEWORK')) {
	die('Illegal call');
}
 
if(!$perm->have_perm_area_action($plugin_name, $plugin_name) && $cronjob != true) {
	exit;
}

// includes
plugin_include('copy_client', 'includes/config.plugin.php');
$plugin_name = "copy_client";
cInclude ("includes", 'functions.database.php');
cInclude ("includes", 'functions.str.php');

$db = new DB_Contenido;
$db2 = new DB_Contenido;

if (!is_object($tpl)) $tpl = new Template;

if ( !isset($_GET["mode"]) ) {

		// Die Infoseite ist derzeit nur auf deutsch erhltlich. Der Text steht im Template.
		$tpl->reset();
		$tpl->set('s', 'URL', $cfg['path']['contenido_fullhtml']);
		$tpl->generate($cfg['templates']['t2tcopyinfo']);

}

if ( $_GET["mode"] == 1 || $_GET["mode"] == 2 ) {

		$stop = false;
		$showformclass = "";
		$errormsg = "";
		
		$tpl->reset();
		
		// Prfen, ob diese Seite ohne Auslsen des Formulars aufgerufen wurde, also default
		if ( $_GET["mode"] == 1 ) 
		{
			$stop = true;
			$errormsg .= i18n("Bitte treffen Sie Ihre Auswahl.", $plugin_name)."<br>";
		}
		
		// berprfen, ob im Zielmandanten berhaupt eine Sprache angelegt wurde. Wenn nicht, zeige kein Formular! 
		$sql = "SELECT * FROM ".$cfg["tab"]["clients_lang"]." WHERE idclient=".$client;	
		$result = $db->query($sql);
		if ( mysql_num_rows($result) == 0 )
		{
		    $errormsg = i18n("Sie mssen fr den Zielmandanten zunchst eine Sprache anlegen. Bis dahin wird die Kopierfunktion gesperrt.", $plugin_name)."<br>";
				$showformclass = "hide";
		}
		// berprfen, ob mehr als eine Sprache angelegt wurde - ablehnen, auf 1 reduzieren einfordern, kein Formular anzeigen
		if ( mysql_num_rows($result) > 1 )
		{
		    $errormsg = i18n("Sie haben mehrere Sprachen fr den neuen Mandanten angelegt. Bitte reduzieren Sie zunchst auf 1 Sprache.", $plugin_name)."<br>";
				$showformclass = "hide";
		}
		
		// berprfe stichprobenartig, ob der Mandant leer zu sein scheint. Wenn nicht, zeige kein Formular! 
		// Dies verhindert auf jeden Fall, dass das Plugin in einem bereits gefllten Mandanten ausgefhrt wird.
		$sql = "SELECT * FROM ".$cfg["tab"]["cat_lang"]." WHERE idlang=".$lang;	
		$result = $db->query($sql);
		if ( mysql_num_rows($result) != 0 )
		{
		    $errormsg  = i18n("Mandant ist nicht leer - es sind Kategorien vorhanden.", $plugin_name)."<br><br>";
		    $errormsg .= i18n("Sie haben mehrere Mglichkeiten:", $plugin_name)."<br><br>";
		    $errormsg .= i18n("- Wechseln Sie in einen leeren Mandanten.", $plugin_name)."<br>";
		    $errormsg .= i18n("- Erstellen Sie einen leeren Mandanten inkl. Sprache und rufen dort dieses Plugin erneut auf.", $plugin_name)."<br>";
		    $errormsg .= i18n("- Leeren Sie diesen Mandanten (Artikel und Kategorien lschen), falls dies Ihr gewnschter Zielmandant ist.", $plugin_name)."<br>";
		    $errormsg .= i18n("Die Kopierfunktion wird nur in einem leeren Mandanten freigeschaltet.", $plugin_name)."<br><br>";
		    $errormsg .= i18n("Das Formular, mit dem Sie die Kopiereinstellungen vornehmen knnen, wird Ihnen erst angezeigt, wenn die Voraussetzungen dafr geschaffen sind.", $plugin_name)."<br>";
				$showformclass = "hide";
		}

		$sql = "SELECT * FROM ".$cfg["tab"]["art_lang"]." WHERE idlang=".$lang;	
		$result = $db->query($sql);
		if ( mysql_num_rows($result) != 0 )
		{
		    $errormsg  = i18n("Mandant ist nicht leer - es sind Artikel und Kategorien vorhanden.", $plugin_name)."<br><br>";
		    $errormsg .= i18n("Sie haben mehrere Mglichkeiten:", $plugin_name)."<br><br>";
		    $errormsg .= i18n("- Wechseln Sie in einen leeren Mandanten.", $plugin_name)."<br>";
		    $errormsg .= i18n("- Erstellen Sie einen leeren Mandanten inkl. Sprache und rufen dort dieses Plugin erneut auf.", $plugin_name)."<br>";
		    $errormsg .= i18n("- Leeren Sie diesen Mandanten (Artikel und Kategorien lschen), falls dies Ihr gewnschter Zielmandant ist.", $plugin_name)."<br><br>";
		    $errormsg .= i18n("Die Kopierfunktion wird nur in einem leeren Mandanten freigeschaltet.", $plugin_name)."<br>";
		    $errormsg .= i18n("Das Formular, mit dem Sie die Kopiereinstellungen vornehmen knnen, wird Ihnen erst angezeigt, wenn die Voraussetzungen dafr geschaffen sind.", $plugin_name)."<br>";
				$showformclass = "hide";
		}

		// Formulareingaben prfen und Variablen auslesen und zuordnen
		if ( $_GET["mode"] == 2 ) {

				// lies bergebene Variablen aus dem Copy-Formular
				$old_idlang     = $_POST["old_idlang"];
				$CopyArtikel    = $_POST["CopyArtikel"];
				$CopyKategorien = $_POST["CopyKategorien"];

				// Unsinnige Checkbox-Angaben ausschlieen
				if ($CopyArtikel == 1 and $CopyKategorien == 0)
				{
				    $errormsg .= i18n("Artikel knnen nur kopiert werden wenn auch die Kategorien kopiert werden sollen.", $plugin_name)."<br>";
				    $stop = true;
				}

		}
		
		if ($stop) {

				// Erstelle das Array mit den Ursprungsmandanten und deren Sprachen
				$sql = "SELECT a.idlang AS oldlang,b.name AS langname,c.name AS clientname FROM ".$cfg["tab"]["clients_lang"]." as a LEFT JOIN ".$cfg["tab"]["lang"]." as b ON (a.idlang=b.idlang)  LEFT JOIN ".$cfg["tab"]["clients"]." as c ON (a.idclient=c.idclient) WHERE a.idclient!=".$client." ORDER BY a.idlang ASC";
				$db->query($sql);
				while($db->next_record()) { $ArrLang[$db->f("oldlang")] = $db->f("clientname")."( ".$db->f("langname").")"; }
		
				// Formularausgabe
				$form['select'] = '<option value="%s"%s>%s</option>'."\n";
				$form['selected'] = ' selected="selected"';

				if (is_array($ArrLang)) {
				    foreach ($ArrLang as $key => $value) {
				        if ($key == $old_idlang)
				            $form['source'] .= sprintf($form['select'], $key, $form['selected'], $value);
				        else
				            $form['source'] .= sprintf($form['select'], $key, "", $value);
						}
				}
		
				$tpl->set('s', 'headline1', i18n("Kopie eines Mandanten anlegen", $plugin_name));
				$tpl->set('s', 'headline2', i18n("Konfigurationseinstellungen", $plugin_name));
				$tpl->set('s', 'text', "" );
				$tpl->set('s', 'error', $errormsg );
		 		$tpl->set('s', 'source', i18n("Ursprungsmandant und -sprache", $plugin_name));
				$tpl->set('s', 'target', i18n("Zielsprache im neuen Mandanten", $plugin_name));
				$tpl->set('s', 'sendbutton', i18n("Starte Kopiervorgang", $plugin_name));
				$tpl->set('s', 'copy_cat', i18n("Kategorien kopieren", $plugin_name));
				$tpl->set('s', 'copy_art', i18n("Artikel kopieren", $plugin_name));
				$tpl->set('s', 'link', $sess->url("main.php?area=$plugin_name&frame=4&mode=2") );
				$tpl->set('s', 'select_source', $form['source'] );
				$tpl->set('s', 'select_target', $form['target'] );
				$tpl->set('s', 'showformclass', $showformclass );
		
				$tpl->generate($cfg['templates']['t2tcopyform']);

				$tpl->set('s', 'URL', $cfg['path']['contenido_fullhtml']);
				$tpl->generate($cfg['templates']['t2tcopyfooter']);
		
		} else { 
		
				/*****************************************************************************************/
				/* Bereite den Kopiervorgang vor                                                         */
				/*****************************************************************************************/
		
				// Fr die Layouts, Module & Templates
				$ArrIdxNeuLayout   = array();
				$ArrIdxNeuModul    = array();
				$ArrIdxNeuTpl      = array();
				$ArrIdxNeuTplConf  = array();
				
				// Fr die Kategorien
				$ArrIdxNeuKat      = array();
				$ArrIdxNeuParentID = array();
				$ArrIdxNeuPostID   = array();
				$ArrIdxNeuPreID    = array();
				
				// Fr die Artikel
				$ArrIdxNeuArt      = array();
				$ArrIdxNeuArtLang  = array();

				// Einige Arrays mssen im 0-Wert initialisiert werden, sonst hagelt es Fehlermeldungen
				$ArrIdxNeuKat[0]   = 0;
				$ArrIdxNeuModul[0] = 0;

				// alte Sprachvariable ist aus dem Formular bereits gesetzt
				// neue Sprachvariable setzen -> die des aktuellen Mandanten
				$new_idlang = $lang;

				// Setze die alte client-Variable, ermittelt aus der Sprachvariablen des Formulars
				$sql = "SELECT * FROM ".$cfg["tab"]["clients_lang"]." WHERE idlang=".$old_idlang;	
				$db->query($sql);
				while($db->next_record()) { $old_idclient = $db->f("idclient");	}

				// Setze die neue client-Variable
				$new_idclient = $client;
				
				$introduce_tablename = i18n("Zu bearbeitende Tabelle",$plugin_name). ": ";
				$seq_msg = i18n("Der Eintrag fr diese Tabelle wurde in der Sequenzer-Tabelle angepasst",$plugin_name).": ".$cfg["tab"]["sequence"]."<br>";
				$lauf_msg = i18n("Anzahl der kopierten Eintrge",$plugin_name).": ";

				// Initialisiere das Rahmentemplate, schreibe die Headerdaten
				$tpl->generate($cfg['templates']['t2tcopyheader']);
				
				$tpl->reset();
				$hdln = i18n("Beginne mit dem Kopiervorgang",$plugin_name)."<br>";
				$msg  = i18n("Ursprungsmandant",$plugin_name).": ".getClientname ($old_idclient)." (".$old_idclient.") <br>";
				$msg .= i18n("Ursprungssprache",$plugin_name).": ".$old_idlang."<br>";
				$msg .= i18n("Zielmandant",$plugin_name).": ".getClientname ($new_idclient)." (".$new_idclient.") <br>";
				$msg .= i18n("Zielsprache",$plugin_name).": ".$new_idlang."<br>";
				$msg .= i18n("Die Vorgnge werden Ihnen im Laufe der Bearbeitung angezeigt. Bitte achten Sie auf mgliche Unstimmigkeiten in den Anzeigen.",$plugin_name)."<br>";
				$tpl->set('s', 'hdln', $hdln );
				$tpl->set('s', 'msg',  $msg );
				$tpl->generate($cfg['templates']['t2tcopymsg']);
				
				/*****************************************************************************************/
				/* Beginne mit den Kopiervorgngen, die ALLE Auftrge betreffen                          */
				/*****************************************************************************************/

				/* MODULE KOPIEREN ***********************************************************************/

				// alle passenden Werte des Ursprungsmandanten ermitteln
				$sql = "SELECT * FROM ".$cfg["tab"]["mod"]." where idclient=".$old_idclient;
				$db->query($sql);
				
				// con_sequence: den aktuellen Index-Wert fr diese Tabelle auslesen (den hchsten Index-Wert der Tabelle ermitteln, ab dem neue Werte generiert werden knnen.
				$MyModSeq = $db->nextid($cfg["tab"]["mod"]);
				
				$lauf=0;
				while($db->next_record())
				{				
						// sammelt die Anzahl der nderungen, das ist manchmal auch ein wichtiger Hinweis bei der Fehlersuche
				    $lauf++;

						// Sammelt die gewnschten Operationen in Textform fr die Templateausgabe
						$modulnamen .= "***** ".$db->f("name").": ".$db->f("idmod")."->".$MyModSeq."<br>";

				    // Arrays: alte Werte sind die Keys, neue Werte die Values im Array
				    // Diese Arrays werden an anderen Stellen wiederkehrend verwendet, daher ist die Reihenfolge der Tabellenbearbeitung wichtig
				    $ArrIdxNeuModul[$db->f("idmod")] = $MyModSeq;

						// Berechnung des SQL-Query. Einige Werte werden gesetzt, die anderen aus den alten Werten bernommen
				    $sql = "INSERT INTO ".$cfg["tab"]["mod"]." VALUES (".$MyModSeq.",".$new_idclient;
				    for ($i=2;$i<$db->num_fields();$i++)
				    {
				        $sql = $sql .",";
				        $cont = $db->Record[$i];
				        $cont = str_replace('\\','\\\\',$cont);
				        $cont = str_replace('"','\"',$cont);
				        $sql = $sql ."\"".$cont."\"";
				    }
				    $sql = $sql .")";
				    $db2->query($sql);
				
				    $MyModSeq++; // erhhe um 1 
				}
				
				// Korrigiere nun noch den Werte in der Tabelle con_sequence
				updateSequence($cfg["tab"]["mod"]);

				// Ausgabe der Meldungen ins Backend
				// Dies protokolliert keine Fehler, sondern das, was gemacht werden sollte;
				// Im Bedarfsfall ist ein Abgleich mit den Tabellen mglich, ob die genannten Werte dort wirklich gelandet sind
				$tpl->reset();
				$hdln = i18n("Kopieren der Module",$plugin_name);
				$msg  = $introduce_tablename.$cfg["tab"]["mod"]."<br>";
				$msg .= i18n("Folgende Module wurden kopiert",$plugin_name).":<br>";
				$msg .= $modulnamen;
				$msg .= $lauf_msg.$lauf."<br>";
				$msg .= $seq_msg;

				$tpl->set('s', 'hdln', $hdln );
				$tpl->set('s', 'msg',  $msg );
				$tpl->generate($cfg['templates']['t2tcopymsg']);
				
				/* LAYOUTS *******************************************************************************/

				// ab hier nur noch spezielle Kommentare zu den Operationen.
				// die Grundbeschreibungen finden sich im Abschnitt "Module"

				$sql = "SELECT * from ".$cfg["tab"]["lay"]." where idclient=".$old_idclient;
				$db->query($sql); 
				
				$MyLaySeq = $db->nextid($cfg["tab"]["lay"]);
				
				$lauf=0;
				while($db->next_record())
				{				
				    $lauf++;
				    $layoutnamen .= "***** ".$db->f("name").": ".$db->f("idlay")."->".$MyLaySeq."<br>";

				    //$ArrIdxAltLayout[]=$db->f("idlay");
				    $ArrIdxNeuLayout[$db->f("idlay")]=$MyLaySeq;

				    $sql = "INSERT INTO ".$cfg["tab"]["lay"]." VALUES (".$MyLaySeq.",".$new_idclient;
				    for ($i=2;$i<$db->num_fields();$i++)
				    {
				        $sql = $sql .",";
				        $cont = $db->Record[$i];
				        $cont = str_replace('\\','\\\\',$cont);
				        $cont = str_replace('"','\"',$cont);
				        $sql = $sql ."\"".$cont."\"";
				    }
				    $sql = $sql .")";
				    $db2->query($sql);
				
				    $MyLaySeq++; 
				}
				
				updateSequence($cfg["tab"]["lay"]);

				$tpl->reset();
				$hdln = i18n("Kopieren der Layouts",$plugin_name);
				$msg  = $introduce_tablename.$cfg["tab"]["lay"]."<br>";
				$msg .= i18n("Folgende Layouts wurden kopiert",$plugin_name).":<br>";
				$msg .= $layoutnamen;
				$msg .= $lauf_msg.$lauf."<br>";
				$msg .= $seq_msg;

				$tpl->set('s', 'hdln', $hdln );
				$tpl->set('s', 'msg',  $msg );
				$tpl->generate($cfg['templates']['t2tcopymsg']);			
				
				/* TEMPLATES (Vorbereitung) *******************************************************************/
	
				$MyTplSeq     = $db->nextid($cfg["tab"]["tpl"]);
				$MyTplConfSeq = $db->nextid($cfg["tab"]["tpl_conf"]);
		
				// Vorgehen: zuerst ermitteln, welches die alten Templates sind. 
				// Dann muss zuerst tpl_conf fr jedes Template gendert werden, damit man die Liste mit den idtplcfg bekommt
				// Ist die da, kann auch con_template gendert werden und in der Folge dann auch con_art_lang
		
				// Vorarbeit: ein Array mit den vorhandenen Templates des alten Mandanten erstellen
				$sql = "SELECT * from ".$cfg["tab"]["tpl"]." where idclient=".$old_idclient." order by idtpl";				
				$db->query($sql); 
				
				while ( $db->next_record() )
				{
				    $ArrIdxNeuTpl[$db->f("idtpl")] = $MyTplSeq; 
				    $MyTplSeq++;
				}
			
				/* TEMPLATEKONFIGURATIONEN *******************************************************************/

			  $lauf=0;
		    foreach ($ArrIdxNeuTpl as $schluessel => $value)
		    { 
					$sql = "SELECT * from ".$cfg["tab"]["tpl_conf"]." where idtpl = ".$schluessel." order by idtplcfg";
					$db->query($sql);
		
					while($db->next_record())
					{
					    $lauf++;
							$tplkonfnamen .=  "***** idtplcfg: ".$db->f("idtplcfg")."->".$MyTplConfSeq."<br>";

					    $ArrIdxNeuTplConf[$db->f("idtplcfg")]=$MyTplConfSeq;

					    $sql = "INSERT INTO ".$cfg["tab"]["tpl_conf"]." (idtplcfg, idtpl, author) VALUES (".$MyTplConfSeq.", ".$ArrIdxNeuTpl[$schluessel].", 'admin')";	
					    $db2->query($sql);

					    $MyTplConfSeq++; 
					}
				}

				updateSequence($cfg["tab"]["tpl_conf"]);

				$tpl->reset();
				$hdln = i18n("Kopieren der Templatekonfigurationen",$plugin_name);
				$msg  = $introduce_tablename.$cfg["tab"]["tpl_conf"]."<br>";
				$msg .= i18n("Folgende Templatekonfigurationen wurden kopiert",$plugin_name).":<br>";
				$msg .= $tplkonfnamen;
				$msg .= $lauf_msg.$lauf."<br>";
				$msg .= $seq_msg;

				$tpl->set('s', 'hdln', $hdln );
				$tpl->set('s', 'msg',  $msg );
				$tpl->generate($cfg['templates']['t2tcopymsg']);

				/* TEMPLATES ******************************************************************************/

			  $lauf=0;
		    foreach ($ArrIdxNeuTpl as $schluessel => $value)
		    {
					$sql = "SELECT * from ".$cfg["tab"]["tpl"]." where idtpl = ".$schluessel;
					$db->query($sql); // kann nur EIN Ergebnis sein in diesem Fall
		
					while($db->next_record())
					{
		
			    	$lauf++;
						$tplnamen .=  "***** ".$db->f("name").": ".$db->f("idtpl")."->".$value."<br>";

				    // Noch eine Mglichkeit, das SQL-Statement aufzubauen. Die neuen Werte werden in modifyValue mit dem Spaltennamen der Tabelle gespeichert
						// und mit changeDbRecord umgeschrieben
				    unset($modifyValue);
				    $modifyValue["idlay"] = $ArrIdxNeuLayout[$db->f("idlay")];
				    $modifyValue["idtpl"] = $ArrIdxNeuTpl[$db->f("idtpl")];
				    $modifyValue["idtplcfg"] = $ArrIdxNeuTplConf[$db->f("idtplcfg")];
				    changeDbRecord($cfg["tab"]["tpl"], $modifyValue);
								
				    $sql = "INSERT INTO ".$cfg["tab"]["tpl"]." VALUES (".$new_idclient;
				    for ($i=1;$i<$db->num_fields();$i++)
				    {
				        $sql .= ",";
				        $cont = $db->Record[$i];
				        $cont = str_replace('\\','\\\\',$cont);
				        $cont = str_replace('"','\"',$cont);
				        $sql .= "\"".$cont."\"";
				    }
				    $sql .= ")";
				    $db2->query($sql);

					}
		
				}

				updateSequence($cfg["tab"]["tpl"]);

				$tpl->reset();
				$hdln = i18n("Kopieren der Templates",$plugin_name);
				$msg  = $introduce_tablename.$cfg["tab"]["tpl"]."<br>";
				$msg .= i18n("Folgende Templates wurden kopiert",$plugin_name).":<br>";
				$msg .= $tplnamen;
				$msg .= $lauf_msg.$lauf."<br>";
				$msg .= $seq_msg;

				$tpl->set('s', 'hdln', $hdln );
				$tpl->set('s', 'msg',  $msg );
				$tpl->generate($cfg['templates']['t2tcopymsg']);

				/* CONTAINER ******************************************************************************/
		
				// Container sind nur an den Index der Templates gebunden, nicht direkt an die idclient bzw. den Mandanten
	
				$sql = "SELECT * from ".$cfg["tab"]["container"]." order by idtpl";
				$db->query($sql); 
				
				$MyContainerSeq = $db->nextid($cfg["tab"]["container"]);
				
				$lauf=0;			
				while($db->next_record())
				{
		        $lauf++;
		
		        unset($modifyValue);
		        $modifyValue["idtpl"] = $ArrIdxNeuTpl[$db->f("idtpl")];
		        if ($db->f("idmod") != 0)  $modifyValue["idmod"] = $ArrIdxNeuModul[$db->f("idmod")];
		        changeDbRecord($cfg["tab"]["container"], $modifyValue);
		
		        $sql = "INSERT INTO ".$cfg["tab"]["container"]." VALUES (".$MyContainerSeq;
		        for ($i=1;$i<$db->num_fields();$i++)
		        {
		            $sql .= ",";
		            $cont = $db->Record[$i];
		            $cont = str_replace('\\','\\\\',$cont);
		            $cont = str_replace('"','\"',$cont);
		
		            $sql .= "\"".$cont."\"";
		        }
		        $sql .= ")";
						$containernamen .=  "***** idcontainer: ".$db->f("idcontainer")."->".$MyContainerSeq." | idtpl: ".$db->f("idtpl")."->".$ArrIdxNeuTpl[$db->f("idtpl")]." | idmod: ".$db->f("idmod")."->".$ArrIdxNeuModul[$db->f("idmod")]."<br>";
		        $db2->query($sql);

		        $MyContainerSeq++;

				}

				updateSequence($cfg["tab"]["container"]);
				
				$tpl->reset();
				$hdln = i18n("Kopieren der Container",$plugin_name);
				$msg  = $introduce_tablename.$cfg["tab"]["container"]."<br>";
				$msg .= i18n("Folgende Container wurden kopiert",$plugin_name).":<br>";
				$msg .= $containernamen;
				$msg .= $lauf_msg.$lauf."<br>";
				$msg .= $seq_msg;

				$tpl->set('s', 'hdln', $hdln );
				$tpl->set('s', 'msg',  $msg );
				$tpl->generate($cfg['templates']['t2tcopymsg']);
				
				/* CONTAINERKONFIGURATIONEN *******************************************************************/
				
				$sql = "SELECT * FROM ".$cfg["tab"]["container_conf"]." order by idtplcfg ";
				$db->query($sql); 
				
				$MyContainerConfSeq = $db->nextid($cfg["tab"]["container_conf"]);
				
				$lauf=0;
				while($db->next_record())
				{
		        $lauf++;
						$containerkonfnamen .=  "***** idtplcfg: ".$db->f("idtplcfg")."->".$MyContainerConfSeq."<br>";

		
		        unset($modifyValue);
		        $modifyValue["idtplcfg"] = $ArrIdxNeuTplConf[$db->f("idtplcfg")];
		        changeDbRecord($cfg["tab"]["container_conf"], $modifyValue);
		
		        $sql = "INSERT INTO ".$cfg["tab"]["container_conf"]." VALUES (".$MyContainerConfSeq;
		        for ($i=1;$i<$db->num_fields();$i++)
		        {
		            $sql .= ",";
		            $cont = $db->Record[$i];
		            $cont = str_replace('\\','\\\\',$cont);
		            $cont = str_replace('"','\"',$cont);
		            $sql .= "\"".$cont."\"";
		        }
		        $sql .= ")";
		        $db2->query($sql);

		        $MyContainerConfSeq++;

				}

				updateSequence($cfg["tab"]["container_conf"]);
				
				$tpl->reset();
				$hdln = i18n("Kopieren der Containerkonfigurationen",$plugin_name);
				$msg  = $introduce_tablename.$cfg["tab"]["container_conf"]."<br>";
				$msg .= i18n("Folgende Containerkonfigurationen wurden kopiert",$plugin_name).":<br>";
				$msg .= $containerkonfnamen;
				$msg .= $lauf_msg.$lauf."<br>";
				$msg .= $seq_msg;

				$tpl->set('s', 'hdln', $hdln );
				$tpl->set('s', 'msg',  $msg );
				$tpl->generate($cfg['templates']['t2tcopymsg']);

				/* MANDANTENEINSTELLUNGEN *******************************************************************/

		    /* Das Feld itemid muss abhngig von itemtype gesondert angepasst werden pro Eintrag 
		       clientsetting hat die idclient und meint die allgemeinen Einstellungen in "Mandanten -> Mandanteneinstellungen"
		       idclient hat die Sprachvariable und steht fr Einstellungen in "Mandanten -> Eigenschaften" 
		       idclientslang hat die Sprachvariable und steht fr Einstellungen in "Mandanten -> Mandanteneinstellungen -> Sprachabhngig" 
		       idlay braucht vermutlich die Nummer des Layouts aus con_lay, das Standardlayout sein soll.
		       update ist mir noch unklar, behlt aber vermutlich seinen Wert in iditem.
		       idlang hat die Sprachvariable, steht aber m.E. flschlich IMMER auf client=1 und steht fr Einstellungen in "Sprachen". Wird nicht mitkopiert, Skript erzwingt vorheriges Anlegen durch den User. */

		    $sql = "SELECT * from ".$cfg["tab"]["properties"]." where idclient=".$old_idclient." AND itemtype != 'idlang' order by idproperty";
		    $db->query($sql); 
		
		    $MyPropSeq = $db->nextid($cfg["tab"]["properties"]);
		
		    $lauf=0;
		    while($db->next_record())
		    {
            $lauf++;
						$mandantennamen .= "***** idproperty: ".$db->f("idproperty")."->".$MyPropSeq." | itemtype: ".$db->f("itemtype")."<br>";

				    unset($modifyValue);
						$tweak_item = $db->f("itemid");
						if ( $db->f("itemtype") == "clientsetting" ) $tweak_item = $new_idclient;
						if ( $db->f("itemtype") == "idclient" )      $tweak_item = $new_idlang;
						if ( $db->f("itemtype") == "idclientslang" ) $tweak_item = $new_idlang;
						if ( $db->f("itemtype") == "idlay" )         $tweak_item = $ArrIdxNeuLayout[$tweak_item];
				    $modifyValue["itemid"] = $tweak_item;
				    changeDbRecord($cfg["tab"]["properties"], $modifyValue);

            $sql = "INSERT INTO ".$cfg["tab"]["properties"]." VALUES (".$MyPropSeq.", ".$new_idclient;
            for ($i=2;$i<$db->num_fields();$i++)
            {
                $sql .= ",";
                $cont = $db->Record[$i];
                $cont = str_replace('\\','\\\\',$cont);
                $cont = str_replace('"','\"',$cont);
                $sql .= "\"".$cont."\"";
            }
            $sql .= ")";
            $db2->query($sql);

            $MyPropSeq++;
		    }
		
		    updateSequence($cfg["tab"]["properties"]);
		
				$tpl->reset();
				$hdln = i18n("Kopieren der Mandanteneinstellungen",$plugin_name);
				$msg  = $introduce_tablename.$cfg["tab"]["properties"]."<br>";
				$msg .= i18n("Folgende Mandanteneinstellungen wurden kopiert",$plugin_name).":<br>";
				$msg .= $mandantennamen;
				$msg .= $lauf_msg.$lauf."<br>";
				$msg .= $seq_msg;

				$tpl->set('s', 'hdln', $hdln );
				$tpl->set('s', 'msg',  $msg );
				$tpl->generate($cfg['templates']['t2tcopymsg']);

				
				/*****************************************************************************************/
				/* Beginne mit den Kopiervorgngen, die Kategorien UND Artikel betreffen (Teil 1)        */
				/*****************************************************************************************/
		
				if ($CopyArtikel==1 and $CopyKategorien==1)
				{

						/* ARTIKEL UND ARTIKEL NUMMERN ********************************************************/

				    // Zuerst die Eintrge der Tabelle con_art_lang anhand der idlang erzeugen - hier stehen die eigentlichen Artikelinhalte
				    // daraus das idart-Array erstellen und die con_art gleich mit aktualisieren, da con_art bei mehreren Sprachen im Ursprungsmandant keine verlssliche Kopiergrundlage liefert wg. fehlender idlang

				    $sql = "SELECT * from ".$cfg["tab"]["art_lang"]." where idlang = ".$old_idlang;
				    $db->query($sql); 
				    $lauf=0;
		
				    $MyArtLangSeq = $db->nextid($cfg["tab"]["art_lang"]);
				    $MyArtSeq     = $db->nextid($cfg["tab"]["art"]);
		
				    while($db->next_record())
				    {
				
							$lauf++;
							
							$ArrIdxNeuArtLang[$db->f("idartlang")] = $MyArtLangSeq;
							$ArrIdxNeuArt[$db->f("idart")]     = $MyArtSeq;
							
							unset($modifyValue);
							
							// time_target_cat = Kategorie, in die nach Zeitablauf der Artikel verschoben wird. 
							// Sollte eigentlich auf 0 gesetzt werden, alte Werte lschen. Neue idcat wre hier noch nicht bekannt.
							$modifyValue["time_target_cat"] = 0;
							changeDbRecord($cfg["tab"]["art_lang"], $modifyValue);
							
							// Wenn idtplcfg=0, dann ist Kategorie nicht konfiguriert -> behalte dann die 0
							if ($db->f("idtplcfg") != 0) 
							{
							    $modifyValue["idtplcfg"] = $ArrIdxNeuTplConf[$db->f("idtplcfg")];
							}
							
							$artinhaltnamen .=  "***** idartlang: ".$db->f("idartlang")."->".$MyArtLangSeq." | idtplcfg: ".$db->f("idtplcfg")."->".$ArrIdxNeuTplConf[$db->f("idtplcfg")]." | time_target_cat: ".$db->f("time_target_cat")."-> NULL<br>";
							$artnamen       .=  "***** idart: ".$db->f("idart")."->".$MyArtSeq."<br>";

							// Trage zunchst die Werte in die con_art_lang ein
	            $sql = "INSERT INTO ".$cfg["tab"]["art_lang"]." VALUES (".$MyArtLangSeq.", ".$MyArtSeq.", ".$new_idlang;			
	            for ($i=3;$i<$db->num_fields();$i++)
	            {
	                $sql .= ",";
	                $cont = $db->Record[$i];
	                $cont = str_replace('\\','\\\\',$cont);
	                $cont = str_replace('"','\"',$cont);
	                $sql .= "\"".$cont."\"";
	            }
	            $sql .= ")";
	            $db2->query($sql);

							// Trage nun die Werte in die con_art ein (das sind jetzt NUR Artikel mit idlang=neu fr diese idclient)
	            $sql = "INSERT INTO ".$cfg["tab"]["art"]." VALUES (".$MyArtSeq.", ".$new_idclient.")";
	            $db2->query($sql);

	            $MyArtLangSeq++; 
	            $MyArtSeq++; 

				    }
		
				    updateSequence($cfg["tab"]["art_lang"]);
				    updateSequence($cfg["tab"]["art"]);

						$tpl->reset();
						$hdln = i18n("Kopieren der Artikelinhalte",$plugin_name);
						$msg  = $introduce_tablename.$cfg["tab"]["art_lang"]."<br>";
						$msg .= i18n("Folgende Artikelinhalte wurden kopiert",$plugin_name).":<br>";
						$msg .= $artinhaltnamen;
						$msg .= $lauf_msg.$lauf."<br>";
						$msg .= $seq_msg;
		
						$tpl->set('s', 'hdln', $hdln );
						$tpl->set('s', 'msg',  $msg );
						$tpl->generate($cfg['templates']['t2tcopymsg']);				
						$tpl->reset();
						$hdln = i18n("Kopieren der Artikelnummern",$plugin_name);
						$msg  = $introduce_tablename.$cfg["tab"]["art"]."<br>";
						$msg .= i18n("Folgende Artikelnummern wurden kopiert",$plugin_name).":<br>";
						$msg .= $artnamen;
						$msg .= $lauf_msg.$lauf."<br>";
						$msg .= $seq_msg;
		
						$tpl->set('s', 'hdln', $hdln );
						$tpl->set('s', 'msg',  $msg );
						$tpl->generate($cfg['templates']['t2tcopymsg']);
				
				} /* Ende von ($CopyArtikel==1 and $CopyKategorien==1) Teil 1 */
		
		
				/*****************************************************************************************/
				/* Beginne mit den Kopiervorgngen, die nur Kategorien betreffen                         */
				/*****************************************************************************************/
				
				if ($CopyKategorien == 1)
				{
				
						/* KATEGORIENAMEN ********************************************************************/

						// wie Artikeln auch, wird die Liste der zu ndernden Werte aus con_cat_lang berechnet, sonst wird bei mehrsprachigen Systemen zuviel kopiert
		
				    $sql = "SELECT * FROM ".$cfg["tab"]["cat_lang"]." where idlang = ".$old_idlang." order by idcat";
				    $db->query($sql);
				
				    $MyKatLangSeq = $db->nextid($cfg["tab"]["cat_lang"]);
				    $MyKatSeq     = $db->nextid($cfg["tab"]["cat"]);

						$lauf = 0;
				    while($db->next_record())
				    {
								$lauf++;

				        $ArrIdxNeuKat[$db->f("idcat")] = $MyKatSeq;
								$catlangnamen .= "***** ".$db->f("name").": ".$db->f("idcatlang")."->".$MyKatLangSeq." | neue idcat : ".$ArrIdxNeuKat[$db->f("idcat")]."<br>";
		
				        unset($modifyValue);
				
								// Wenn idtplcfg=0, dann ist Kategorie nicht konfiguriert, behalte dann die 0
				        if ($db->f("idtplcfg") != 0)
				        {
				            $modifyValue["idtplcfg"] = $ArrIdxNeuTplConf[$db->f("idtplcfg")]; 
				        }
	
								// Startartikel setzen
				        $modifyValue["startidartlang"] = $ArrIdxNeuArtLang[$db->f("startidartlang")]; 		
				        changeDbRecord($cfg["tab"]["cat_lang"], $modifyValue);

								// ab hier wird con_cat_lang gespeichert
				        $sql = "INSERT INTO ".$cfg["tab"]["cat_lang"]." VALUES (".$MyKatLangSeq.",".$MyKatSeq.",".$new_idlang;
				        for ($i=3;$i<$db->num_fields();$i++)
				        {
				            $sql .= ",";
				            $cont = $db->Record[$i];
				            $cont = str_replace('\\','\\\\',$cont);
				            $cont = str_replace('"','\"',$cont);
				            $sql .= "\"".$cont."\"";
				        }
				        $sql .= ")";
				        $db2->query($sql);
							
				        $MyKatLangSeq++;
				        $MyKatSeq++;
				
				    } 
				
				    updateSequence($cfg["tab"]["cat_lang"]);
				
						$tpl->reset();
						$hdln = i18n("Kopieren der Kategorienamen und -bezeichner",$plugin_name);
						$msg  = $introduce_tablename.$cfg["tab"]["cat_lang"]."<br>";
						$msg .= i18n("Folgende Artikelnamen und -bezeichner wurden kopiert",$plugin_name).":<br>";
						$msg .= $catlangnamen;
						$msg .= $lauf_msg.$lauf."<br>";
						$msg .= $seq_msg;
		
						$tpl->set('s', 'hdln', $hdln );
						$tpl->set('s', 'msg',  $msg );
						$tpl->generate($cfg['templates']['t2tcopymsg']);	

						/* KATEGORIEBUME ********************************************************************/

				    // Die neuen idcat wurden in $ArrIdxNeuKat bereits erzeugt, allerdings noch mit den alten Werten fr parentid, preid und postid
				    // Das muss nun mit Hilfe der folgenden Schleifen noch korrigiert werden
				    // ACHTUNG: Ist parentid, preid oder postid 0, so bleibt es 0!																	

						// Zunchst einmalig die komplette alte con_cat auslesen fr sptere Referenz:
						$sql = "SELECT * from ".$cfg["tab"]["cat"]." order by idcat";	
		    		$concatcomplete = mysql_query($sql);
						while ( $row = mysql_fetch_array($concatcomplete) ) {
							$ArrFullCat[$row["idcat"]]["parentid"] = $row["parentid"];
							$ArrFullCat[$row["idcat"]]["preid"]    = $row["preid"];
							$ArrFullCat[$row["idcat"]]["postid"]   = $row["postid"];
						}

				    // parentid
				    $lauf=0;
				    foreach ($ArrIdxNeuKat as $schluessel =>$value)
				    {

								$sql = "SELECT * from ".$cfg["tab"]["cat"]." WHERE idcat=".$schluessel." order by idcat";	
				    		$db->query($sql);

						    while($db->next_record())
						    {

								// Das folgende Verhalten lsst sich am Beispiel des Demomandanten erklren. Dort gibt es 1 Mandant mit 2 Sprachen.
								// Die Sprachen haben eine unterschiedliche Anzahl von angezeigten Kategorien. Dennoch ist grundstzlich die Baumstruktur in con_cat fr beide Sprachen gleich.
								// Wird in Sprache 2 der (verknappte) Baum angezeigt, so werden dennoch die Werte aus con_cat gezogen, wie sie fr den vollen Baum gelten wrden.
								// Nicht bentigte Kategorien werden nachrangig nicht angezeigt. Die parentid, preid und postid sind also fr BEIDE Sprachen identisch.
								// Will man die (knappere) Sprache 2 kopieren und kopiert brav den (vollen) Baum, sind in der Kopie zuviele und falsche Informationen enthalten.
								// Die folgenden Schleifen kennen bereits den angestrebten Zielbaum und korrigieren die Werte fr parentid, preid und postid, 
								// indem sie anhand der Originalbume im Abgleich zu den Zielbumen ermitteln, welche Kategorien nicht gebraucht werden 
								// und wie die nchsten logischen IDs auszusehen haben.

								// parentid
								if ( !isset($ArrIdxNeuKat[$db->f("parentid")]) )
								{
									$checkid = false;
									$followid = $db->f("parentid");

									while ( !$checkid ) {

										$followid = $ArrFullCat[$followid]["parentid"];
																			
										if ( isset($ArrIdxNeuKat[$followid]) )
										{
											$ArrIdxNeuParentID[$schluessel]   = $ArrIdxNeuKat[$followid];
											$checkid = true;
										}
									}

								} else {
				        	$ArrIdxNeuParentID[$schluessel]   = $ArrIdxNeuKat[$db->f("parentid")];
								}

								// preid
								if ( !isset($ArrIdxNeuKat[$db->f("preid")]) )
								{
									$checkid = false;
									$followid = $db->f("preid");

									while ( !$checkid ) {

										$followid = $ArrFullCat[$followid]["preid"];
																			
										if ( isset($ArrIdxNeuKat[$followid]) )
										{
											$ArrIdxNeuPreID[$schluessel]   = $ArrIdxNeuKat[$followid];
											$checkid = true;
										}
									}

								} else {
				        	$ArrIdxNeuPreID[$schluessel]   = $ArrIdxNeuKat[$db->f("preid")];
								}

								// postid
								if ( !isset($ArrIdxNeuKat[$db->f("postid")]) )
								{
									$checkid = false;
									$followid = $db->f("postid");

									while ( !$checkid ) {

										$followid = $ArrFullCat[$followid]["postid"];
																			
										if ( isset($ArrIdxNeuKat[$followid]) )
										{
											$ArrIdxNeuPostID[$schluessel]   = $ArrIdxNeuKat[$followid];
											$checkid = true;
										}
									}

								} else {
				        	$ArrIdxNeuPostID[$schluessel]   = $ArrIdxNeuKat[$db->f("postid")];
								}

								$catnamen .= "***** Anpassungen: idcat (alt): ".$schluessel." | idcat (neu): ".$value." | parentid neu:". $ArrIdxNeuParentID[$schluessel]." | ";
								$catnamen .= "preid neu:". $ArrIdxNeuPreID[$schluessel]." | postid neu:". $ArrIdxNeuPostID[$schluessel]."<br>";
				        
				        unset($modifyValue);
				        $modifyValue["parentid"] = $ArrIdxNeuParentID[$schluessel];
				        $modifyValue["preid"]    = $ArrIdxNeuPreID[$schluessel];
				        $modifyValue["postid"]   = $ArrIdxNeuPostID[$schluessel];
		
				        changeDbRecord($cfg["tab"]["cat"], $modifyValue);
		
				        $sql = "INSERT INTO ".$cfg["tab"]["cat"]." VALUES (".$value.", ".$new_idclient;
				        for ($i=2;$i<$db->num_fields();$i++)
				        {
				            $sql .= ",";
				            $cont = $db->Record[$i];
				            $cont = str_replace('\\','\\\\',$cont);
				            $cont = str_replace('"','\"',$cont);
				            $sql .= "\"".$cont."\"";
				        }
				        $sql .= ")";
				        $db2->query($sql);

								$lauf++;
							}
				    }

				    updateSequence($cfg["tab"]["cat"]);
						
						$tpl->reset();
						$hdln = i18n("Kopieren der Kategorienummern",$plugin_name);
						$msg  = $introduce_tablename.$cfg["tab"]["cat"]."<br>";
						$msg .= i18n("Folgende Kategoriewerte fr wurden kopiert",$plugin_name).":<br>";
						$msg .= $catnamen."<br>";
						$msg .= $lauf_msg.$lauf."<br>";
						$msg .= $seq_msg;
		
						$tpl->set('s', 'hdln', $hdln );
						$tpl->set('s', 'msg',  $msg );
						$tpl->generate($cfg['templates']['t2tcopymsg']);	
				
				} /* End if von if ($CopyKategorien==1) */
				
				/*****************************************************************************************/
				/* Fahre fort mit den Kopiervorgngen, die Kategorien UND Artikel betreffen (Teil 2)     */
				/*****************************************************************************************/
		
		
				if ($CopyArtikel==1 and $CopyKategorien==1)
				{

						/* ARTIKEL DEN KATEGORIEN ZUORDNEN ***************************************************/
					
				    $MyCatArtSeq = $db->nextid($cfg["tab"]["cat_art"]);

						// Die Menge der zu ndernden Eintrge wurde bereits frher ermittelt und wird in foreach durchlaufen
				    $lauf=0;
		    		foreach ($ArrIdxNeuArt as $schluessel => $artvalue)
				    {

								$sql = "SELECT * from ".$cfg["tab"]["cat_art"]." where idart = ".$schluessel." order by idcatart";
								$db->query($sql);
					
								while($db->next_record())
								{
								    $lauf++;
										$catartnamen .= "***** idcatart: ".$db->f("idcatart")."->".$MyCatArtSeq." | idart: ".$db->f("idart")."->".$ArrIdxNeuArt[$db->f("idart")]." | idcat: ".$db->f("idcat")."->".$ArrIdxNeuKat[$db->f("idcat")]."<br>";
			
				            $sql = "INSERT INTO ".$cfg["tab"]["cat_art"]." VALUES (".$MyCatArtSeq.", ".$ArrIdxNeuKat[$db->f("idcat")].", ".$ArrIdxNeuArt[$db->f("idart")];
				
				            for ($i=3;$i<$db->num_fields();$i++)
				            {
				                $sql .= ",";
				                $cont = $db->Record[$i];
				                $cont = str_replace('\\','\\\\',$cont);
				                $cont = str_replace('"','\"',$cont);
				                $sql .= "\"".$cont."\"";
				            }
				            $sql .= ")";
				            $db2->query($sql);

				            $MyCatArtSeq++;
										}

				    }
				
				    updateSequence($cfg["tab"]["cat_art"]);
				
						$tpl->reset();
						$hdln = i18n("Kopieren der Zuordnung Kategorien <-> Artikel",$plugin_name);
						$msg  = $introduce_tablename.$cfg["tab"]["cat_art"]."<br>";
						$msg .= i18n("Folgende Zuordnungen wurden kopiert",$plugin_name).":<br>";
						$msg .= $catartnamen;
						$msg .= $lauf_msg.$lauf."<br>";
						$msg .= $seq_msg;
		
						$tpl->set('s', 'hdln', $hdln );
						$tpl->set('s', 'msg',  $msg );
						$tpl->generate($cfg['templates']['t2tcopymsg']);
		
		
						/* ARTIKELINHALTE (CONTENT) ***************************************************/

						$MyContSeq     = $db->nextid($cfg["tab"]["content"]);
		
						// Die Menge der zu ndernden Eintrge wurde bereits frher ermittelt und wird in foreach durchlaufen
					  $lauf=0;
				    foreach ($ArrIdxNeuArtLang as $schluessel => $value)
				    {
							$sql = "SELECT * from ".$cfg["tab"]["content"]." where idartlang = ".$schluessel." order by idtype";
							$db->query($sql);
		
							while($db->next_record())
							{
						    $lauf++;
								
						    unset($modifyValue);
						    $modifyValue["idartlang"] = $ArrIdxNeuArtLang[$schluessel];
						    changeDbRecord($cfg["tab"]["content"], $modifyValue);
						
						    $sql = "INSERT INTO ".$cfg["tab"]["content"]." VALUES (".$MyContSeq;
						    for ($i=1;$i<$db->num_fields();$i++)
						    {
						        $sql .= ",";
						        $cont = $db->Record[$i];
						        $cont = str_replace('\\','\\\\',$cont);
						        $cont = str_replace('"','\"',$cont);
						        $sql .= "\"".$cont."\"";
						    }						
						    $sql .= ")";
						    $db2->query($sql);

								$contentnamen .= "***** idcontent: ".$db->f("idcontent")."->".$MyContSeq." | idartlang: ".$db->f("idartlang")."->".$ArrIdxNeuArtLang[$schluessel]."<br>";

							  $MyContSeq++;
							}
						}

						updateSequence($cfg["tab"]["content"]);
		
						$tpl->reset();
						$hdln = i18n("Kopieren der Artikelinhalte (Content)",$plugin_name);
						$msg  = $introduce_tablename.$cfg["tab"]["content"]."<br>";
						$msg .= i18n("Folgende Artikelinhalte wurden kopiert",$plugin_name).":<br>";
						$msg .= $contentnamen;
						$msg .= $lauf_msg.$lauf."<br>";
						$msg .= $seq_msg;
		
						$tpl->set('s', 'hdln', $hdln );
						$tpl->set('s', 'msg',  $msg );
						$tpl->generate($cfg['templates']['t2tcopymsg']);
		
						/* METATAGS *********************************************************************/
		
						$MyMetaSeq     = $db->nextid($cfg["tab"]["meta_tag"]);
		
						// Die Menge der zu ndernden Eintrge wurde bereits frher ermittelt und wird in foreach durchlaufen
				    $lauf=0;				
				    foreach ($ArrIdxNeuArtLang as $schluessel => $value)
				    {
							$sql = "SELECT * from ".$cfg["tab"]["meta_tag"]." where idartlang = ".$schluessel." order by idmetatag";
							$db->query($sql);
		
							while($db->next_record())
							{
						    $lauf++;		
						
						    unset($modifyValue);
						    $modifyValue["idartlang"] = $ArrIdxNeuArtLang[$schluessel];
						    changeDbRecord($cfg["tab"]["meta_tag"], $modifyValue);
						
						    $sql = "INSERT INTO ".$cfg["tab"]["meta_tag"]." VALUES (".$MyMetaSeq;
						    for ($i=1;$i<$db->num_fields();$i++)
						    {
						        $sql .= ",";
						        $cont = $db->Record[$i];
						        $cont = str_replace('\\','\\\\',$cont);
						        $cont = str_replace('"','\"',$cont);
						        $sql .= "\"".$cont."\"";
						    }
						    $sql .= ")";
						    $db2->query($sql);

								$metanamen .= "***** idmetatag: ".$db->f("idmetatag")."->".$MyMetaSeq." | idartlang: ".$db->f("idartlang")."->".$ArrIdxNeuArtLang[$schluessel]." | Inhalt: ".$db->f("metavalue")."<br>";

							  $MyMetaSeq++;		
							}
						}

						updateSequence($cfg["tab"]["meta_tag"]);
		
						$tpl->reset();
						$hdln = i18n("Kopieren der Metatags",$plugin_name);
						$msg  = $introduce_tablename.$cfg["tab"]["meta_tag"]."<br>";
						$msg .= i18n("Folgende Metatags wurden kopiert",$plugin_name).":<br>";
						$msg .= $metanamen;
						$msg .= $lauf_msg.$lauf."<br>";
						$msg .= $seq_msg;
		
						$tpl->set('s', 'hdln', $hdln );
						$tpl->set('s', 'msg',  $msg );
						$tpl->generate($cfg['templates']['t2tcopymsg']);
		
				} /* End if von ($CopyArtikel==1 and $CopyKategorien==1) */

				/*****************************************************************************************/
				/* Finale Arbeiten                                                                       */
				/*****************************************************************************************/

				// Sicherheitshalber con_cat_tree neu aufbauen
				// Hierfr wird per Skript in den neuen Mandanten gewechselt, da die Funktion nur den Baum des aktuellen Mandanten neu erstellt:
				$db     = new DB_Contenido;
				$client = $new_idclient;
				$lang   = $new_idlang;
				strRemakeTreeTable();
		
				$tpl->reset();
				$hdln = i18n("Der Kopiervorgang ist beendet.",$plugin_name);
				$msg  = i18n("Der Kategoriebaum wurde neu eingelesen, und im Backend wurde bereits in den neuen Mandanten gewechselt.",$plugin_name)."<br>";
				$msg .= i18n("Bitte kontrollieren Sie die nderungen sorgfltig.",$plugin_name)."<br>";
				$msg .= i18n("Alle nderungen ohne Gewhr.",$plugin_name)."<br>";
				$msg .= i18n("Diverse Mandanteneinstellungen, Module und sonstige Elemente mssen hndisch an die neuen idart, idcat, idcatart usw. angepasst werden.",$plugin_name)."<br>";

				$tpl->set('s', 'hdln', $hdln );
				$tpl->set('s', 'msg',  $msg );
				$tpl->generate($cfg['templates']['t2tcopymsg']);
								
				// Beende das Template, schreibe die Fudaten
				$tpl->set('s', 'URL', $cfg['path']['contenido_fullhtml']);
				$tpl->generate($cfg['templates']['t2tcopyfooter']);
		
		}

} // end of mode = 1


/*******************************************************/
/* Functions *******************************************/
/*******************************************************/

// Updates in der con_sequence vornehmen
function updateSequence($table=false) {

    global $db, $cfg;

    if (!$table) {
        $sql = "SHOW TABLES";
        $db->query($sql);
        while ($db->next_record())
        {
            dbUpdateSequence($cfg['sql']['sqlprefix']."_sequence", $db->f(0), $db);
        }
    } else {
        dbUpdateSequence($cfg['sql']['sqlprefix']."_sequence", $table, $db);
    }
}

// change $db Record by name
//
// modify values of $db record by name
// $table specifies the table name
// $valueArray must be an Array with
// syntax $valueArray["fieldname"] = "new value";
//
// @author horwath@dayside.net
function changeDbRecord($table, $valueArray) {

    global $db, $db2;

    // $db2 muss hier verwendet werden !!
    $values = $db2->metadata($table);

    // get field names and position
    $pos = 0;
    foreach ($values as $key) {
        $thisPosition[$key["name"]] = $pos;
        $pos++;
    }

    if ($pos==0) {
        echo "no field names found in table";
        die();
    }

    // modify $db->Record[]
    foreach ($valueArray as $name => $value) {

        if (!isset($thisPosition[$name])) {
            echo "sorry this $name does not exist in definied table<br>\n";
            echo "available fields in table: <b>".$table."</b><br>\n";
            echo "<pre>";
            print_r($thisPosition);
            echo "</pre>";
            die();
        } else {

            if (!isset($db->Record[$thisPosition[$name]])) {

               echo "no value stored in \$db->Record[".$thisPosition[$name]."]<br>";
               echo "you should check table: '".$table."' ,field:'".$name."'<br>";
               echo "skipping setting value to: '".$value."'<br>";
               echo "DB Record:";
               echo "<pre>";
               print_r($db->Record);
               echo "</pre>";

            } else {

               // change field value
               $db->Record[$thisPosition[$name]] = $value;

            }

        }

    }
}
?>