<?php
/**
 * Project: Copy Client Plugin
 * Contenido Content Management System
 * 
 * Description: 
 * Config file for copy client plugin
 * 
 * Requirements: 
 * @con_php_req 5.0
 * 
 *
 * @package    Contenido Backend plugins
 * @version    1.0
 * @author     Viktor Lehmann
 * @copyright  TONE2TONE <www.tone2tone.com>
 * @license    unter Verwendung von
 * @link       Axel/emergence
 * @since      file available since contenido release 4.8.13
 * 
 * {@internal 
 *   created 2010-09-20
 *   modified 
 *
 *   $Id: config.plugin.php 305 2010-09-20 $:
 * }}
 * 
 */

if(!defined('CON_FRAMEWORK')) {
	die('Illegal call');
}

$plugin_name = "copy_client";

// Die folgenden Eintrge bitte nicht ndern!
$cfg['plugins']['copy_client']       = $cfg['path']['contenido'] . "plugins/" . $plugin_name . "/";
$cfg['plugins']['copy_client_path']  = $cfg['path']['contenido_fullhtml'] . "plugins/" . $plugin_name . "/";

// Templates
$cfg['templates']['t2tcopypage']     = $cfg['plugins']['copy_client'] . "templates/standard/page.html";
$cfg['templates']['t2tcopyheader']   = $cfg['plugins']['copy_client'] . "templates/standard/page_header.html";
$cfg['templates']['t2tcopyfooter']   = $cfg['plugins']['copy_client'] . "templates/standard/page_footer.html";
$cfg['templates']['t2tcopyform']     = $cfg['plugins']['copy_client'] . "templates/standard/page_copyform.html";
$cfg['templates']['t2tcopymsg']      = $cfg['plugins']['copy_client'] . "templates/standard/page_messages.html";
$cfg['templates']['t2tcopyinfo']     = $cfg['plugins']['copy_client'] . "templates/standard/page_info.html";

?>